<?php
require_once("nusoap/nusoap.php");

define('URBANDICT_KEY', '7b0c6eab1bfe408045920373470f1420');

function get_definitions($term) {
	$soap = new SoapClient('http://api.urbandictionary.com/soap?wsdl', true);
	return $soap->call('lookup', array(URBANDICT_KEY, $term));
}

$term   = array_key_exists('term',   $_GET) ? $_GET['term'  ] : '';
$format = array_key_exists('format', $_GET) ? $_GET['format'] : 'txt';

switch ($format) {
	case 'txt':
		header("Content-type: text/plain");
		if (!$term) {
			print("No term given.");
		} else if ($definitions = get_definitions($term)) {
			print($definitions[0]['definition']);
		} else {
			print("No definitions found.");
		}
		break;
	
	case 'xml':
		header("Content-type: text/xml");
		printf("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
		printf("<entries term=\"%s\"", htmlspecialchars($term));
		if (!$term) {
			printf(" error=\"No term given\">");
		} else if ($definitions = get_definitions($term)) {
			printf(">\n");
			foreach($definitions as $definition) {
				printf("  <entry author=\"%s\">\n", htmlspecialchars($definition['author']));
				printf("    <definition>\n");
				printf("      %s\n", htmlspecialchars($definition['definition']));
				printf("    </definition>\n");
				printf("    <example>\n");
				printf("      %s\n", htmlspecialchars($definition['example']));
				printf("    </example>\n");
				printf("  </entry>\n");
			}
		} else {
			printf(" error=\"No definitions found\">");
		}
		printf("</entries>\n");
		break;
	
	default:
		header("Content-type: text/plain");
		print("Invalid output format specified - must be one of \"txt\" or \"xml\".\n");
		break;
}

?>